<?php
/*
    Parseur de donnes pour il-2/fb.
    Copyright (C) 2006,2007  Pain Julien

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Trouve dans un tableau la ligne qui contient un mot a une place precise : retourne le numero de la ligne
function trouver_ligne($tableau, $mot, $place, $lignemin, $lignemax){
      $i=$lignemin;
      while(trim($tableau[$i][$place])!=$mot and $i<$lignemax){
          $i++;
          // echo $mot;
          // echo $tableau[$i][$place];
          // echo $i."<br>";
          }
      return $i;
}


// Affiche un tableau en entier sur une ligne
function afficher_ligne($ligne){
      $i=0;
      $imax=count($ligne);
//      echo $imax;
      for ($i=0; $i<=$imax; $i++){
        echo "|";
        echo $ligne[$i];
        }
      echo "<br>";
}


// Permet de trouver les infos de la mission (ET CA DEPEND DE LA LANGUE!! :/ GRRR): retourne un tableau jour/mois/annee/nom_mission
function get_mission_info($ligne){
      //afficher_ligne($ligne);
      $i=0;
      $imax=count($ligne);
      $ligne[0]=substr($ligne[0], 1, strlen($ligne[0]));
      $ligne[$imax]='';
      $ligne[($imax-1)]='';
      $ligne[($imax-2)]='';
      
      if ("Mission:"==$ligne[2]){
          $test=split_point($ligne[0]);
          echo $test[0];
          if ($test[0]<=31){
              echo "systeme russe";
              $ligne[1]=substr($ligne[1], 0, 8);
              $ligne[0]=split_point($ligne[0]);
              $return[0]=$ligne[0][0];
              $return[1]=$ligne[0][1];
              $return[2]=substr($ligne[0][2], 2, 4);
              $return[3]=$ligne[1];
              $return[4]="";
              for ($i=3; $i<=($imax); $i++){
                  $return[4]=$return[4].$ligne[$i]." ";
                  }
              }
            else {
              echo "systeme allemand";
              $ligne[1]=substr($ligne[1], 0, 8);
              $ligne[0]=split_point($ligne[0]);
              $return[0]=$ligne[0][2];
              $return[1]=$ligne[0][1];
              $return[2]=substr($ligne[0][0], 2, 4);
              $return[3]=$ligne[1];
              $return[4]="";
              for ($i=3; $i<=($imax); $i++){
                  $return[4]=$return[4].$ligne[$i]." ";
                  }
              }
          }
      if ("Mission:"==$ligne[4]){
          echo "systeme francais";
          $ligne[3]=substr($ligne[3], 0, 8);
          // afficher_ligne($ligne);
          for ($i=0; $i<4; $i++){
              $return[$i]=$ligne[$i];
              }
          switch($return[1]){
              case 'janv.': $return[1]=1; break;
              case 'fvr.': $return[1]=2; break;
              case 'mars': $return[1]=3; break;
              case 'avr.': $return[1]=4; break;
              case 'mai': $return[1]=5; break;
              case 'juin': $return[1]=6; break;
              case 'juil.': $return[1]=7; break;
              case 'aot': $return[1]=8; break;
              case 'sept.': $return[1]=9; break;
              case 'oct.': $return[1]=10; break;
              case 'nov.': $return[1]=11; break;
              case 'dc.': $return[1]=12; break;
              }
          $return[4]="";
          for ($i=5; $i<=($imax); $i++){
              $return[4]=$return[4].$ligne[$i]." ";
              }
          }
      if ("Mission:"==$ligne[5]){
          echo "systeme anglais";
          $return[0]=substr($ligne[1], 0, strlen($ligne[1])-1);
          $return[1]=$ligne[0];
          $return[2]=substr($ligne[2], 2, 4);
          $return[3]=$ligne[3];
          if ($ligne[4]="PM]") {
              $ligne[3]=$ligne[3]+12;
              $return[3]=$ligne[3].strstr($return[3],":");
              }
          switch($return[1]){
              case 'Jan': $return[1]=1; break;
              case 'Feb': $return[1]=2; break;
              case 'Mar': $return[1]=3; break;
              case 'Apr': $return[1]=4; break;
              case 'May': $return[1]=5; break;
              case 'Jun': $return[1]=6; break;
              case 'Jul': $return[1]=7; break;
              case 'Aug': $return[1]=8; break;
              case 'Sep': $return[1]=9; break;
              case 'Oct': $return[1]=10; break;
              case 'Nov': $return[1]=11; break;
              case 'Dec': $return[1]=12; break;
              }
          $return[4]="";
          for ($i=6; $i<=($imax); $i++){
              $return[4]=$return[4].$ligne[$i]." ";
              }
          }
      //afficher_ligne($return);
      return $return;
}


// Parse un fichier texte, et le retourne sous forme de tableau
function parseur($fichier){
	echo "<br>Analyse du fichier : ".$fichier."<br>";
        $fp = file($fichier);	// ouverture du fichier en lecture
        $maxligne = count($fp);echo "Nombre de lignes : ".$maxligne."<br>";
        $mots=0;
        $parse=array();
        $i = 0;
        while ($i <= $maxligne-1){
          $j=$i+1;
    //          echo 'voici la ligne numero : '.$j.'<br>';
    //          echo $fp[$i];          
          $lign=split_words($fp[$i]);
          $max = count($lign);
    //          echo "<br>Nombre de mots dans cette ligne : ".$max."<br>";
          $mots=$mots+$max;
          $k = 0;
          while ($k <= $max-1){
            $parse[$i][$k]=$lign[$k];
    //            echo $lign[$k];
    //            echo ' | ';
            $k++;
            }
    //          echo '<br>';echo '<br>';           
    //          echo '<br>';
          $i++;
          }
    echo "nombre de mots total : ".$mots."<br>";
    //   echo 'Voici le 6eme mot de la ligne 99 : '.$parse[100][5];
    echo "fin du parseur<br><br>";
    return $parse;
}


// Test fichier mission correct
function test_mission($mission){
    if (
        $mission[1][0]=="MAP" and
        $mission[2][0]=="TIME" and (
        ($mission[3][0]=="CloudType" and 
        $mission[4][0]=="CloudHeight") or
        ($mission[4][0]=="CloudType" and 
        $mission[5][0]=="CloudHeight") or 
        ($mission[5][0]=="CloudType" and 
        $mission[6][0]=="CloudHeight"))){
        $return=TRUE;
        }
      else {
        $return=FALSE;
        }
      return $return;
}


// Test fichier log correct
function test_log($log){
    $maxligne=count($log);
    $nbEnd=0;
    for ($i=0; $i<=$maxligne; $i++){
        if ($log[$i][1]=="Mission" and "END"==trim($log[$i][2])){
            $nbEnd=$nbEnd+1;
            }
        }
    if ($nbEnd==1){
        $return=TRUE;
        }
      else {
        $return=FALSE;
        }
    return $return;
}


// Test fichier log/mis correspondant (anti_slash ou slash suivant le type de server)
function test_mislog($fichier3,$nom_mis){
    //$temp1=split_anti_slash($fichier3);
    $temp1=split_slash($fichier3);
    $temp1=$temp1[count($temp1)-1];
    // echo $temp1;
    $temp2=split_slash($nom_mis);
    $temp2=$temp2[count($temp2)-1];
    $temp2=substr($temp2, 0, strlen($temp2)-4);
    // echo $temp2;
    if ($temp1==$temp2){
        $return=TRUE;
        }
      else {
        $return=FALSE;
        }
    return $return;
}


function trouver_avion($squads, $nb_squad, $avion){
    $j=0;
    $trouve=0;
    $avion=substr($avion, 0, strlen($avion)-1);
    //echo "cherche".$avion."<br>";
    while ($j!=$nb_squad and $trouve==0){
        //echo $squads[0][$j]."a<br>";
        if (trim($squads[0][$j])==$avion){
            //echo "trouve";
            //echo $squads[0][$j].$squads[1][$j].$squads[2][$j]."<br>";
            $typeavion=$squads[1][$j];
            $trouve=1;
            }
        $j++;
        }
    return $typeavion;
}

function trouver_cible_fixe($squads, $nb_squad, $avion){
    $j=0;
    $trouve=0;
    //$avion=substr($avion, 0, strlen($avion)-1);
    //echo "cherche".$avion."-<br>";
    while ($j!=$nb_squad and $trouve==0){
        //echo $squads[$j][0]."<br>";
        if (trim($squads[$j][0])==$avion){
            //echo "trouve";
            $typeavion=$squads[$j][1];
            $trouve=1;
            }
        $j++;
        }
    return $typeavion;
}

function trouver_cible_mobile($squads, $nb_squad, $avion){
    $j=0;
    $trouve=0;
    $avion=substr($avion, 0, strlen($avion)-1);
    //echo "cherche".$avion."-<br>";
    while ($j!=$nb_squad and $trouve==0){
        //echo $squads[$j][0]."<br>";
        if (trim($squads[$j][0])==$avion){
            //echo "trouve";
            $typeavion=$squads[$j][1];
            $trouve=1;
            }
        $j++;
        }
    return $typeavion;
}

// fonction d'ajout/soustraction d'heures du type (heure1, heure2(plus tard), operateur'plus'ou'moins') retourne une heure HH:MM:SS
function operation_heure($heure1,$heure2,$operation){
    $heure1=split_2points($heure1);
    $heure2=split_2points($heure2);
    //echo $heure1[0]."<br>";
    //echo $heure1[1]."<br>";
    //echo $heure1[2]."<br>";
    //echo $heure2[0]."<br>";
    //echo $heure2[1]."<br>";
    //echo $heure2[2]."<br>";
  
    if ($operation=="plus"){
        $heuref_s=$heure2[2]+$heure1[2];
        $heuref_m=$heure2[1]+$heure1[1];
        $heuref_h=$heure2[0]+$heure1[0];
        }
    if ($operation=="moins"){
        $heuref_s=$heure2[2]-$heure1[2];
        $heuref_m=$heure2[1]-$heure1[1];
        $heuref_h=$heure2[0]-$heure1[0];
        }
    
    if ($heuref_s>=60) {
        $heuref_s=$heuref_s-60;
        $heuref_m=$heuref_m+1;
        }
    if ($heuref_s<0) {
        $heuref_s=$heuref_s+60;
        $heuref_m=$heuref_m-1;
        }
    if ($heuref_m>=60) {
        $heuref_m=$heuref_m-60;
        $heuref_h=$heuref_h+1;
        }
    if ($heuref_m<0) {
        $heuref_m=$heuref_m+60;
        $heuref_h=$heuref_h-1;
        }
    if ($heuref_h<0) {
        $heuref_h=$heuref_h+24;
        }

    if (strlen($heuref_h)<=1) $sep_h='0';
    if (strlen($heuref_m)<=1) $sep_m='0';
    if (strlen($heuref_s)<=1) $sep_s='0';
    $heuref=$sep_h.$heuref_h.":".$sep_m.$heuref_m.":".$sep_s.$heuref_s;
    //echo $heuref;
    return $heuref;
}

// affiche l'heure en "plus sympa"
function afficher_heure($heure){
    $heure=split_2points($heure);
    $heure_h=$heure[0];
    $heure_m=$heure[1];
    if (strlen($heure_h)<=1) $heure_h='0'.$heure_h;
    if (strlen($heure_m)<=1) $heure_m='0'.$heure_m;
    if ($heure_h=='00') {
        $heure_r=$heure_m.' min';
        }
      else {
        $heure_r=$heure_h.' h '.$heure_m;
        }
    return $heure_r;
}


// compte les elements d'une liste pour les rendres sous forme : X1 evement1 X2 evenement2 ...etc, X est le nombre de fois que l'evenement  t rencontr
function resumer_liste($liste){
    $liste_parse=split_words($liste);
    //echo count($liste_parse);
    $temp_liste="";
    $liste_retour="";
    for ($m=0; $m<count($liste_parse);$m++){
        $nb_evenement=0;
        //echo rawurlencode($liste_parse[$m])."<br>";
        if (ereg(rawurlencode($liste_parse[$m]),rawurlencode($temp_liste))){
            }
          else {
            for ($n=0; $n<count($liste_parse);$n++){
                //echo "$".$liste_parse[$m]."=?".$liste_parse[$n]."<br>";
                if ($liste_parse[$m]==$liste_parse[$n]){
                    $nb_evenement=$nb_evenement+1;
                    //echo $nb_evenement."<br>";
                    }
                }
            $liste_retour=$liste_retour." ".$nb_evenement." ".$liste_parse[$m];
            $temp_liste=$temp_liste." ".$liste_parse[$m];
            //echo $liste_retour."<br>";
            //echo $temp_liste."<br>";
            }
        }
    return $liste_retour;
}

function sommmer_liste($liste1,$liste2){
    $liste1_parse=split_words($liste1);
    $liste2_parse=split_words($liste2);
    //$liste_sum=array();
    $liste_retour="";
    //afficher_ligne($liste1_parse);
    //afficher_ligne($liste2_parse);
    for ($m=1; $m<count($liste1_parse);$m=$m+2){
        //$liste_sum[$m-1]=$liste1_parse[$m-1];
        //$liste_sum[$m]=$liste1_parse[$m];
        for ($n=1; $n<count($liste2_parse);$n=$n+2){
            if ($liste1_parse[$m]==$liste2_parse[$n]){
                $liste1_parse[$m-1]=$liste1_parse[$m-1]+$liste2_parse[$n-1];
                //$liste_sum[$m-1]=$liste_sum[$m-1]+$liste2_parse[$n-1];
                }
            }
        }
    for ($n=1; $n<count($liste2_parse);$n=$n+2){
        $trouve=0;
        for ($m=1; $m<count($liste1_parse);$m=$m+2){
            if ($liste1_parse[$m]==$liste2_parse[$n])
            $trouve=1;
            }
        if ($trouve==0){
            //echo "nombre:".count($liste1_parse)."<br>";
            $liste1_parse[count($liste1_parse)]=$liste2_parse[$n-1];
            $liste1_parse[count($liste1_parse)]=$liste2_parse[$n];
            }
        }
    for ($m=0; $m<count($liste1_parse); $m++){
        $liste_retour=$liste_retour." ".$liste1_parse[$m];
        }
    return $liste_retour;
}

// cree une liste a partir d'un texte en appliquant une classe
function lister_liste($liste_t,$classe){
    $liste_temp=split_words($liste_t);
    $liste_w='<ul class="'.$classe.'">';
    //echo count($liste_temp);
    for ($i=0; $i<count($liste_temp); $i++){
        $liste_w=$liste_w."<li>".$liste_temp[$i]."</li>";
        }
    $liste_w=$liste_w."</ul>";
    //echo $liste_w;
    return $liste_w;
}

// cree un tableau a 2 dimension  partir d'une liste
function tabler_liste($liste_t){
    $liste_temp=split_words($liste_t);
    $tableau=array();
    $j=0;
    for ($i=0; $i<count($liste_temp); $i=$i+2){
        $tableau[$j][0]=$liste_temp[$i];
        $tableau[$j][1]=$liste_temp[$i+1];
        $j++;
        }
    return $tableau;
}

// renvoit le temps par rapport au chiffre
function obtenir_temps($chiffre){
    switch ($chiffre){
        case 0: $temps="Clair";break;
        case 1: $temps="Bon";break;
        case 2: $temps="Brumeux";break;
        case 3: $temps="Mauvais";break;
        case 4: $temps="Visibilit nulle";break;
        case 5: $temps="Pluie / Neige";break;
        case 6: $temps="Orageux";break;
        }
    return $temps;
}

function soustraire_liste($liste1,$liste2){
    $liste1_parse=split_words($liste1);
    $liste2_parse=split_words($liste2);
    $liste_retour="";
    //afficher_ligne($liste1_parse);
    //afficher_ligne($liste2_parse);
    for ($m=1; $m<count($liste1_parse);$m=$m+2){
        for ($n=1; $n<count($liste2_parse);$n=$n+2){
            if ($liste1_parse[$m]==$liste2_parse[$n]){
                $liste1_parse[$m-1]=$liste1_parse[$m-1]-$liste2_parse[$n-1];
                }
            }
        }
    for ($m=1; $m<count($liste1_parse);$m=$m+2){
        if ($liste1_parse[$m-1]!=0){
            $liste_retour=$liste_retour." ".$liste1_parse[$m-1];
            $liste_retour=$liste_retour." ".$liste1_parse[$m];
            }
        }
    return $liste_retour;
}

function enlever_de_liste($liste,$obj){
    $liste_parse=split_words($liste);
    $liste_retour="";
    for ($m=0; $m<count($liste_parse); $m++){
        if (trim($liste_parse[$m])!=trim($obj)){
            $liste_retour=$liste_retour." ".$liste_parse[$m];
            }
        }
    return $liste_retour;
}

// test d'une heure  + ou - 1 seconde
function test_heure_approx($heure1,$heure2){
    $tps1=$heure1[0]*3600+$heure1[1]*60+$heure1[2];
    $tps2=$heure2[0]*3600+$heure2[1]*60+$heure2[2];
    if ($tps1==86399 and $tps2==0 or $tps1==0 and $tps2==86399){
      return TRUE;
      }
    else {
      if ($tps1==$tps2 or $tps1==$tps2+1 or $tps1==$tps2-1){
        return TRUE;
        }
      else {
        return FALSE;
        }
      }
}

?>
